Program OCR;

CONST MAX = 50;

Type TScanat = Array[1..MAX, 1..MAX] Of Real; {imaginea scanata}
     Element = Record          {voi retine imaginea intr-un tablou}
                 i, j: Word;   {in care pentru fiecare element (i,j)}
                 Di, Dj: Real  {retin diferentele fata de linia i,}
               End;            {respectiv fata de coloana j}
Var T   : TScanat;                      {imaginea scanata}
    Min : Array[1..MAX*MAX] Of Element; {tabloul cu diferente}
    n, m: Word;
    f   : Text;

Procedure Citire;
Var i, j: Word;
Begin
  Assign(f, 'ocr.in'); Reset(f);
  ReadLn(f, n, m);
  For i := 1 To n Do
    For j := 1 To m Do
      Read(f, T[i, j]);
  Close(f)
End;

Procedure Afisare(PMin: Word);
Begin
  Assign(f, 'ocr.out'); ReWrite(f);
  {afisez coordonatele minimului gasit}
  WriteLn(f, Min[PMin].i, ' ', Min[PMin].j);
  Close(f)
End;

Function Suma(l1, c1, l2, c2: Word): Real;
Var l, c: Word;
    Sum : Real;
Begin
  Sum := 0;
  For l := l1 To l2 Do
    For c := c1 To c2 Do
      Sum := Sum+T[l, c];
  Suma := Sum
End;

Procedure Calcul;
Var i, j       : Word;
    Index, PMin: Word;
    Aux        : Element;
    Ordonat    : Boolean;
    Minim      : Real;
Begin
  For i := 1 To n Do
    For j := 1 To m Do
      Begin
        Index := (i-1)*m+j;  {pozitia in tablou}
        Min[Index].i := i;   {retin linia si}
        Min[Index].j := j;   {retin coloana}
        {retin diferenta dintre suma sus si suma jos}
        Min[Index].Di := Abs(Suma(1, 1, i-1, m)-Suma(i+1, 1, n, m));
        {retin diferenta dintre suma stanga si suma dreapta}
        Min[Index].Dj := Abs(Suma(1, 1, n, j-1)-Suma(1, j+1, n, m));
      End;
  Ordonat := FALSE;                   {ordonez crescator vectorul rezultat}
  While NOT Ordonat Do                {dupa diferenta sus-jos}
    Begin
      Ordonat := TRUE;
      For i := 1 To n*m-1 Do
        If Min[i].Di>Min[i+1].Di Then
          Begin
            Aux := Min[i];
            Min[i] := Min[i+1];
            Min[i+1] := Aux;
            Ordonat := FALSE
          End;
    End;
  Index := 1;           {apoi pentru toate elementele minime egale}
  Minim := Min[Index].Dj; PMin := Index; {caut minimul stanga-dreapta}
  Index := Index+1;
  While (Min[Index].Di=Min[1].Di) AND (Index<=n*m) Do
    Begin
      If Min[Index].Dj <= Minim Then
        Begin
          Minim := Min[Index].Dj;
          PMin := Index
        End;
      Index := Index+1
    End;
  Afisare(PMin);       {elementul gasit este cel cautat}
End;

Begin  {program principal}
  Citire;
  Calcul;
End.   {program principal}
